<?php 

namespace Kaomoji;

use Concrete\Core\Editor\Plugin;
use Concrete\Core\Asset\AssetList as AssetList;
use \Concrete\Core\Support\Facade\Application as Application;
use Log;

class Kaomoji
{
    
    protected static $app;
    
    protected static $_plugins = array();
    
    protected static $_editorType;
    
    protected static function setApp()
    {
        if (!isset(self::$app) || !self::$app) {
            self::$app = Application::getFacadeApplication();
        }
    }

    protected static function getPluginsToInstall()
    {
        return array('kaomoji' => t('Kaomojis (Japanese emojis)'));
    }

    public static function ActivatePlugins()
    {
        if (!self::$app) {
            self::setApp();
        }

        $editor = self::$app->make('editor');
        self::$_editorType = get_Class($editor);

        if (strpos(self::$_editorType, 'Ckeditor')) {
            $pluginManager = $editor->getPluginManager();
            $plugins = self::getPluginsToInstall();

            foreach ($plugins as $pluginHandle => $pluginName) {
                $plugin = self::getPlugin($pluginHandle, $pluginName);
                if (!$pluginManager->isAvailable($plugin)) {
                // [NOUR] this puts the plugin in the list of available plugins
                    // it still needs to be selected
                    $pluginManager->register($plugin);
                }
                if (!$pluginManager->isSelected($plugin)) {
                    
                    // enable the plugin !!!!!
                    // [NOUR] this selects (enables) the plugin putting it in the list of selected plugins
                    // this is what makes the checkbox be checked in the list of plugins in the dashboard
                    $key = $plugin->getKey();
                    $pluginManager->select($key);
                }
            }
        } else {
            return false;
        }

    }

    /**
     */
    protected static function getPlugin($pluginHandle, $pluginName)
    {
        if (!self::$_plugins[$pluginHandle] || !is_object(self::$_plugins[$pluginHandle])) {  // no need to do this again for next editor
            $plugin = null;
            $options = null;
            $al = AssetList::getInstance();
            if (strpos(self::$_editorType, 'Ckeditor')) {
                
                $al->register('javascript', 'editor/ckeditor4/'.$pluginHandle,
                    'js/plugins/'.$pluginHandle.'/register.js', array(), 'ckeditor_kaomoji');
                $al->registerGroup('editor/ckeditor4/'.$pluginHandle, array(
                    array('javascript', 'editor/ckeditor4/'.$pluginHandle)
                ));
                
                $plugin = new Plugin();
                $plugin->setKey($pluginHandle);
                $plugin->setName($pluginName);
                $plugin->requireAsset('editor/ckeditor4/'.$pluginHandle);
                
            }
            
            self::$_plugins[$pluginHandle] = $plugin;
        }
        
        return $plugin;
    }

}